Attribute VB_Name = "modV2Math"
Option Explicit

Public Type Vector
  x As Single
  y As Single
End Type

Public Function Vector(ByVal x As Single, ByVal y As Single) As Vector
  Vector.x = x
  Vector.y = y
End Function

Public Function vNorm(v As Vector) As Vector
  Dim s As Single

  s = 1 / vLen(v)
  vNorm.x = v.x * s
  vNorm.y = v.y * s
End Function

Public Function vAdd(v1 As Vector, v2 As Vector) As Vector
  vAdd.x = v1.x + v2.x
  vAdd.y = v1.y + v2.y
End Function

Public Function vScale(v As Vector, s As Single) As Vector
  vScale.x = v.x * s
  vScale.y = v.y * s
End Function

Public Function vSubt(v1 As Vector, v2 As Vector) As Vector
  vSubt.x = v1.x - v2.x
  vSubt.y = v1.y - v2.y
End Function

Public Function vCCW(v1 As Vector, v2 As Vector) As Single
  vCCW = v1.x * v2.y - v1.y * v2.x
End Function

Public Function vDP2(v1 As Vector, v2 As Vector) As Single
  vDP2 = v1.x * v2.x + v1.y * v2.y
End Function

Public Function vLen(v As Vector) As Single
  vLen = Sqr(v.x * v.x + v.y * v.y)
End Function
